Loading...
Searching...
No Matches
juce::MidiMessageSequence Class Reference

## Detailed Description

A sequence of timestamped midi messages.

This allows the sequence to be manipulated, and also to be read from and written to a standard midi file.

See also
  MidiMessage, MidiFile

The documentation for this class was generated from the following file:

- juce_audio_basics/midi/juce_MidiMessageSequence.h

## Classes

class | MidiEventHolder
| Structure used to hold midi events in the sequence. More...

## Public Member Functions

| MidiMessageSequence ()
| Creates an empty midi sequence object.
| MidiMessageSequence (const MidiMessageSequence &)
| Creates a copy of another sequence.
MidiMessageSequence & | operator= (const MidiMessageSequence &)
| Replaces this sequence with another one.
| MidiMessageSequence (MidiMessageSequence &&) noexcept
| Move constructor.
MidiMessageSequence & | operator= (MidiMessageSequence &&) noexcept
| Move assignment operator.
void | clear ()
| Clears the sequence.
int | getNumEvents () const noexcept
| Returns the number of events in the sequence.
MidiEventHolder * | getEventPointer (int index) const noexcept
| Returns a pointer to one of the events.
MidiEventHolder ** | begin () noexcept
| Iterator for the list of MidiEventHolders.
MidiEventHolder *const * | begin () const noexcept
| Iterator for the list of MidiEventHolders.
MidiEventHolder ** | end () noexcept
| Iterator for the list of MidiEventHolders.
MidiEventHolder *const * | end () const noexcept
| Iterator for the list of MidiEventHolders.
double | getTimeOfMatchingKeyUp (int index) const noexcept
| Returns the time of the note-up that matches the note-on at this index.
int | getIndexOfMatchingKeyUp (int index) const noexcept
| Returns the index of the note-up that matches the note-on at this index.
int | getIndexOf (const MidiEventHolder *event) const noexcept
| Returns the index of an event.
int | getNextIndexAtTime (double timeStamp) const noexcept
| Returns the index of the first event on or after the given timestamp.
double | getStartTime () const noexcept
| Returns the timestamp of the first event in the sequence.
double | getEndTime () const noexcept
| Returns the timestamp of the last event in the sequence.
double | getEventTime (int index) const noexcept
| Returns the timestamp of the event at a given index.
MidiEventHolder * | addEvent (const MidiMessage &newMessage, double timeAdjustment=0)
| Inserts a midi message into the sequence.
MidiEventHolder * | addEvent (MidiMessage &&newMessage, double timeAdjustment=0)
| Inserts a midi message into the sequence.
void | deleteEvent (int index, bool deleteMatchingNoteUp)
| Deletes one of the events in the sequence.
void | addSequence (const MidiMessageSequence &other, double timeAdjustmentDelta, double firstAllowableDestTime, double endOfAllowableDestTimes)
| Merges another sequence into this one.
void | addSequence (const MidiMessageSequence &other, double timeAdjustmentDelta)
| Merges another sequence into this one.
void | updateMatchedPairs () noexcept
| Makes sure all the note-on and note-off pairs are up-to-date.
void | sort () noexcept
| Forces a sort of the sequence.
void | extractMidiChannelMessages (int channelNumberToExtract, MidiMessageSequence &destSequence, bool alsoIncludeMetaEvents) const
| Copies all the messages for a particular midi channel to another sequence.
void | extractSysExMessages (MidiMessageSequence &destSequence) const
| Copies all midi sys-ex messages to another sequence.
void | deleteMidiChannelMessages (int channelNumberToRemove)
| Removes any messages in this sequence that have a specific midi channel.
void | deleteSysExMessages ()
| Removes any sys-ex messages from this sequence.
void | addTimeToMessages (double deltaTime) noexcept
| Adds an offset to the timestamps of all events in the sequence.
void | createControllerUpdatesForTime (int channelNumber, double time, Array< MidiMessage > &resultMessages)
| Scans through the sequence to determine the state of any midi controllers at a given time.
void | swapWith (MidiMessageSequence &) noexcept
| Swaps this sequence with another one.

## Constructors and Destructors

## MidiMessageSequence() [1/3]

juce::MidiMessageSequence::MidiMessageSequence | ( |  | ) |

Creates an empty midi sequence object.

Referenced by addSequence(), addSequence(), extractMidiChannelMessages(), extractSysExMessages(), MidiFile, MidiMessageSequence(), MidiMessageSequence(), operator=(), operator=(), and swapWith().

## MidiMessageSequence() [2/3]

juce::MidiMessageSequence::MidiMessageSequence | ( | const MidiMessageSequence & |  | ) |

Creates a copy of another sequence.

References MidiMessageSequence().

## MidiMessageSequence() [3/3]

juce::MidiMessageSequence::MidiMessageSequence | ( | MidiMessageSequence && |  | ) |

noexcept

Move constructor.

References MidiMessageSequence().

## Member Functions

## operator=() [1/2]

MidiMessageSequence & juce::MidiMessageSequence::operator= | ( | const MidiMessageSequence & |  | ) |

Replaces this sequence with another one.

References MidiMessageSequence().

## operator=() [2/2]

MidiMessageSequence & juce::MidiMessageSequence::operator= | ( | MidiMessageSequence && |  | ) |

noexcept

Move assignment operator.

References MidiMessageSequence().

## clear()

void juce::MidiMessageSequence::clear | ( |  | ) |

Clears the sequence.

## getNumEvents()

int juce::MidiMessageSequence::getNumEvents | ( |  | ) | const

noexcept

Returns the number of events in the sequence.

## getEventPointer()

MidiEventHolder * juce::MidiMessageSequence::getEventPointer | ( | int | index | ) | const

noexcept

Returns a pointer to one of the events.

References getEventPointer().

Referenced by getEventPointer().

## begin() [1/2]

MidiEventHolder ** juce::MidiMessageSequence::begin | ( |  | ) |

noexcept

Iterator for the list of MidiEventHolders.

References begin().

Referenced by begin(), and begin().

## begin() [2/2]

MidiEventHolder *const * juce::MidiMessageSequence::begin | ( |  | ) | const

noexcept

Iterator for the list of MidiEventHolders.

References begin().

## end() [1/2]

MidiEventHolder ** juce::MidiMessageSequence::end | ( |  | ) |

noexcept

Iterator for the list of MidiEventHolders.

References end().

Referenced by end(), and end().

## end() [2/2]

MidiEventHolder *const * juce::MidiMessageSequence::end | ( |  | ) | const

noexcept

Iterator for the list of MidiEventHolders.

References end().

## getTimeOfMatchingKeyUp()

double juce::MidiMessageSequence::getTimeOfMatchingKeyUp | ( | int | index | ) | const

noexcept

Returns the time of the note-up that matches the note-on at this index.

If the event at this index isn't a note-on, it'll just return 0.

See also
  MidiMessageSequence::MidiEventHolder::noteOffObject

References getTimeOfMatchingKeyUp().

Referenced by getTimeOfMatchingKeyUp().

## getIndexOfMatchingKeyUp()

int juce::MidiMessageSequence::getIndexOfMatchingKeyUp | ( | int | index | ) | const

noexcept

Returns the index of the note-up that matches the note-on at this index.

If the event at this index isn't a note-on, it'll just return -1.

See also
  MidiMessageSequence::MidiEventHolder::noteOffObject

References getIndexOfMatchingKeyUp().

Referenced by getIndexOfMatchingKeyUp().

## getIndexOf()

int juce::MidiMessageSequence::getIndexOf | ( | const MidiEventHolder * | event | ) | const

noexcept

Returns the index of an event.

References getIndexOf().

Referenced by getIndexOf().

## getNextIndexAtTime()

int juce::MidiMessageSequence::getNextIndexAtTime | ( | double | timeStamp | ) | const

noexcept

Returns the index of the first event on or after the given timestamp.

If the time is beyond the end of the sequence, this will return the number of events.

References getNextIndexAtTime().

Referenced by getNextIndexAtTime().

## getStartTime()

double juce::MidiMessageSequence::getStartTime | ( |  | ) | const

noexcept

Returns the timestamp of the first event in the sequence.

See also
  getEndTime

References getStartTime().

Referenced by getStartTime().

## getEndTime()

double juce::MidiMessageSequence::getEndTime | ( |  | ) | const

noexcept

Returns the timestamp of the last event in the sequence.

See also
  getStartTime

References getEndTime().

Referenced by getEndTime().

## getEventTime()

double juce::MidiMessageSequence::getEventTime | ( | int | index | ) | const

noexcept

Returns the timestamp of the event at a given index.

If the index is out-of-range, this will return 0.0

References getEventTime().

Referenced by getEventTime().

## addEvent() [1/2]

MidiEventHolder * juce::MidiMessageSequence::addEvent | ( | const MidiMessage & | newMessage,
|  | double | timeAdjustment = 0 )

Inserts a midi message into the sequence.

The index at which the new message gets inserted will depend on its timestamp, because the sequence is kept sorted.

Remember to call updateMatchedPairs() after adding note-on events.

Parameters

  newMessage | the new message to add (an internal copy will be made)
  timeAdjustment | an optional value to add to the timestamp of the message that will be inserted

See also
  updateMatchedPairs

References addEvent().

Referenced by addEvent(), addEvent(), and MidiFile.

## addEvent() [2/2]

MidiEventHolder * juce::MidiMessageSequence::addEvent | ( | MidiMessage && | newMessage,
|  | double | timeAdjustment = 0 )

Inserts a midi message into the sequence.

The index at which the new message gets inserted will depend on its timestamp, because the sequence is kept sorted.

Remember to call updateMatchedPairs() after adding note-on events.

Parameters

  newMessage | the new message to add (an internal copy will be made)
  timeAdjustment | an optional value to add to the timestamp of the message that will be inserted

See also
  updateMatchedPairs

References addEvent().

## deleteEvent()

void juce::MidiMessageSequence::deleteEvent | ( | int | index,
|  | bool | deleteMatchingNoteUp )

Deletes one of the events in the sequence.

Remember to call updateMatchedPairs() after removing events.

Parameters

  index | the index of the event to delete
  deleteMatchingNoteUp | whether to also remove the matching note-off if the event you're removing is a note-on

References deleteEvent().

Referenced by deleteEvent().

## addSequence() [1/2]

void juce::MidiMessageSequence::addSequence | ( | const MidiMessageSequence & | other,
|  | double | timeAdjustmentDelta,
|  | double | firstAllowableDestTime,
|  | double | endOfAllowableDestTimes )

Merges another sequence into this one.

Remember to call updateMatchedPairs() after using this method.

Parameters

  other | the sequence to add from
  timeAdjustmentDelta | an amount to add to the timestamps of the midi events as they are read from the other sequence
  firstAllowableDestTime | events will not be added if their time is earlier than this time. (This is after their time has been adjusted by the timeAdjustmentDelta)
  endOfAllowableDestTimes | events will not be added if their time is equal to or greater than this time. (This is after their time has been adjusted by the timeAdjustmentDelta)

References addSequence(), and MidiMessageSequence().

Referenced by addSequence(), and addSequence().

## addSequence() [2/2]

void juce::MidiMessageSequence::addSequence | ( | const MidiMessageSequence & | other,
|  | double | timeAdjustmentDelta )

Merges another sequence into this one.

Remember to call updateMatchedPairs() after using this method.

Parameters

  other | the sequence to add from
  timeAdjustmentDelta | an amount to add to the timestamps of the midi events as they are read from the other sequence

References addSequence(), and MidiMessageSequence().

## updateMatchedPairs()

void juce::MidiMessageSequence::updateMatchedPairs | ( |  | ) |

noexcept

Makes sure all the note-on and note-off pairs are up-to-date.

Call this after re-ordering messages or deleting/adding messages, and it will scan the list and make sure all the note-offs in the MidiEventHolder structures are pointing at the correct ones.

References updateMatchedPairs().

Referenced by updateMatchedPairs().

## sort()

void juce::MidiMessageSequence::sort | ( |  | ) |

noexcept

Forces a sort of the sequence.

You may need to call this if you've manually modified the timestamps of some events such that the overall order now needs updating.

References sort().

Referenced by sort().

## extractMidiChannelMessages()

void juce::MidiMessageSequence::extractMidiChannelMessages | ( | int | channelNumberToExtract,
|  | MidiMessageSequence & | destSequence,
|  | bool | alsoIncludeMetaEvents ) const

Copies all the messages for a particular midi channel to another sequence.

Parameters

  channelNumberToExtract | the midi channel to look for, in the range 1 to 16
  destSequence | the sequence that the chosen events should be copied to
  alsoIncludeMetaEvents | if true, any meta-events (which don't apply to a specific channel) will also be copied across.

See also
  extractSysExMessages

References extractMidiChannelMessages(), and MidiMessageSequence().

Referenced by extractMidiChannelMessages().

## extractSysExMessages()

void juce::MidiMessageSequence::extractSysExMessages | ( | MidiMessageSequence & | destSequence | ) | const

Copies all midi sys-ex messages to another sequence.

Parameters

  destSequence | this is the sequence to which any sys-exes in this sequence will be added

See also
  extractMidiChannelMessages

References extractSysExMessages(), and MidiMessageSequence().

Referenced by extractSysExMessages().

## deleteMidiChannelMessages()

void juce::MidiMessageSequence::deleteMidiChannelMessages | ( | int | channelNumberToRemove | ) |

Removes any messages in this sequence that have a specific midi channel.

Parameters

  channelNumberToRemove | the midi channel to look for, in the range 1 to 16

References deleteMidiChannelMessages().

Referenced by deleteMidiChannelMessages().

## deleteSysExMessages()

void juce::MidiMessageSequence::deleteSysExMessages | ( |  | ) |

Removes any sys-ex messages from this sequence.

References deleteSysExMessages().

Referenced by deleteSysExMessages().

## addTimeToMessages()

void juce::MidiMessageSequence::addTimeToMessages | ( | double | deltaTime | ) |

noexcept

Adds an offset to the timestamps of all events in the sequence.

Parameters

  deltaTime | the amount to add to each timestamp.

References addTimeToMessages().

Referenced by addTimeToMessages().

## createControllerUpdatesForTime()

void juce::MidiMessageSequence::createControllerUpdatesForTime | ( | int | channelNumber,
|  | double | time,
|  | Array< MidiMessage > & | resultMessages )

Scans through the sequence to determine the state of any midi controllers at a given time.

This will create a sequence of midi controller changes that can be used to set all midi controllers to the state they would be in at the specified time within this sequence.

As well as controllers, it will also recreate the midi program number and pitch bend position.

This function has special handling for the "bank select" and "data entry" controllers (0x00, 0x20, 0x06, 0x26, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65).

If the sequence contains multiple bank select and program change messages, only the bank select messages immediately preceding the final program change message will be kept.

All "data increment" and "data decrement" messages will be retained. Some hardware will ignore the requested increment/decrement values, so retaining all messages is the only way to ensure compatibility with all hardware.

"Parameter number" changes will be slightly condensed. Only the parameter number events immediately preceding each data entry event will be kept. The parameter number will also be set to its final value at the end of the sequence, if necessary.

Parameters

  channelNumber | the midi channel to look for, in the range 1 to 16. Controllers for other channels will be ignored.
  time | the time at which you want to find out the state - there are no explicit units for this time measurement, it's the same units as used for the timestamps of the messages
  resultMessages | an array to which midi controller-change messages will be added. This will be the minimum number of controller changes to recreate the state at the required time.

References createControllerUpdatesForTime().

Referenced by createControllerUpdatesForTime().

## swapWith()

void juce::MidiMessageSequence::swapWith | ( | MidiMessageSequence & |  | ) |

noexcept

Swaps this sequence with another one.

References MidiMessageSequence(), and swapWith().

Referenced by swapWith().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited